<template>
  <div class="app-container app-containerth">
    <el-row style="margin-top: 18px;" class="searBoxstu" >
      <el-col :span="5" class="searBoxs">
        <el-row class="roleBoxui" >
          <el-col :span="24" class="roleBotyu" style="height: 100%;">
            <el-row :gutter="10" class="mb8" style="height: 100%;">
            <el-col :span="1.5">
              <el-button type="primary" style="background-color: #FF9639;color: #fff;border: none;" plain icon="el-icon-refresh"
                @click="efresh" v-hasPermi="['system:role:list']">刷新</el-button>
            </el-col>
            </el-row>
          </el-col>
          </el-row>
        <div class="searBox">
          <div class="searInput">
            <input type="text" placeholder="请输入角色" v-model="queryParams.roleName">
          </div>
          <div class="searBtn" @click="quregu">
            <img src="@/assets/images/icon_sr_ss@2x.png" alt="" class="icon">
          </div>
        </div>
        <div class="searList">
          <div class="searItem" v-for="(item,index) in roleList" :key="item.roleName" :class="[indexdw == index? 'active' : '']" @click="jieese(item.id,index)">
            {{item.roleName}}
          </div>
        </div>
        <pagination sty v-show="totale>0" :total="totale" layout="prev, pager, next" :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize" @pagination="getList" small />
      </el-col>
      <el-col :span="19" class="roleContr">
        <el-row class="roleBox">
          <el-col :span="24" class="roleBot">
            <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
              <el-button type="primary" style="background-color: #2AC1CA;color: #fff;border: none;" plain icon="el-icon-plus"
                @click="handleAdd" v-hasPermi="['system:role:add']">新增</el-button>
            </el-col>
            <el-col :span="1.5">
              <el-button type="primary" style="background-color: #FF9639;color: #fff;border: none;" plain icon="el-icon-edit"
                @click="handleUpdate" :disabled="single" v-hasPermi="['system:role:list']">修改</el-button>
            </el-col>
            <el-col :span="1.5">
              <el-button type="primary" :disabled="multiple" style="background-color: #3C8DBC;color: #fff;border: none;" plain icon="el-icon-delete"
                @click="handleDelete" v-hasPermi="['system:role:edit']">删除</el-button>
            </el-col>
            </el-row>
          </el-col>
          </el-row>
        <div class="roleContrBox roleContrBoxthy">
          <el-col :span="24">
            <div class="searContLeft">
              <el-table v-loading="loading" :data="cloumns" @selection-change="handleSelectionChange" :max-height="tableHeight">
                <el-table-column type="selection"   width="55" align="center" />
                <el-table-column label="序号" align="center"  prop="id" />
                <el-table-column label="用户角色" align="center" prop="roleName" />
                <el-table-column label="权限表单" align="center" prop="tableName" />
                <el-table-column label="数据过滤" align="center" prop="dataScope">
                  <!-- <template slot-scope="scope">
                    {{scope.row.dataScope | relationTypeFn}}
                  </template> -->
                </el-table-column>
                <el-table-column  label="是否可用"  align="center">
                  <!-- <template slot="header" slot-scope="scope">
                    <div><el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange"></el-checkbox>数据过滤4</div>
                  </template> -->
                  <template slot-scope="scope">
                    <el-checkbox true-label="Y" false-label="N" v-model="scope.row.isUse" ></el-checkbox>
                  </template>
                </el-table-column>
              </el-table>
            </div>
          </el-col>
        <pagination
           v-show="total>0"
           :total="total"
           :page.sync="queryParamstr.pageNum"
           :limit.sync="queryParamstr.pageSize"
           @pagination="getDeptTreeselect"
           class="pajie"
         />
        </div>
      </el-col>
    </el-row>

    <!-- 添加或修改对话框 -->
    <el-dialog :close-on-click-modal="false" :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="权限表单：" prop="tableName">
          <el-input v-model="form.tableName" placeholder="请输入权限表单" />
        </el-form-item>
        <el-form-item label="权限范围：" prop="dataScope">
         <el-select style="width: 100%;" v-model="form.dataScope" placeholder="权限范围" clearable size="small">
           <el-option
             v-for="dict in statusOptions"
             :key="dict.dictValue"
             :label="dict.dictLabel"
             :value="dict.dictValue"
           />
         </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import { listRole, getRole, delRole, addRole, updateRole, exportRole, dataScope, changeRoleStatus } from "@/api/system/role";
  import { treeselect as menuTreeselect, roleMenuTreeselect } from "@/api/system/menu";
  import { treeselect as deptTreeselect, roleDeptTreeselect } from "@/api/system/dept";
  import { listPostporen, addlistPostporen, getRoler,delelistPostporen,piutRoler } from "@/api/system/permisss.js";
  export default {
    name: "Role",
    data() {
      return {
        searIndex: '',
        defaultProps: {
          children: 'children',
          label: 'label'
        },
        indexs: 3,
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        totale:0,
        // 角色表格数据
        roleList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 是否显示弹出层（数据权限）
        openDataScope: false,
        menuExpand: false,
        menuNodeAll: false,
        deptExpand: true,
        deptNodeAll: false,
        // 日期范围
        dateRange: [],
        // 状态数据字典
        statusOptions: [],
        // 数据范围选项
        // 菜单列表
        menuOptions: [],
        // 部门列表
        deptOptions: [],
        // 查询参数
        queryParams: {
          roleName: undefined,
          roleId: undefined,
          status: undefined,
          pageNum: 1,
          pageSize: 10,
        },
        queryParamstr:{
          pageNum: 1,
          pageSize: 10,
          roleId: undefined,
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
          roleName: [{
            required: true,
            message: "角色名称不能为空",
            trigger: "blur"
          }],
          roleKey: [{
            required: true,
            message: "权限字符不能为空",
            trigger: "blur"
          }],
          roleSort: [{
            required: true,
            message: "角色顺序不能为空",
            trigger: "blur"
          }]
        },
        cloumns:[],
        relationType: [],
        // 表格的高度
        tableHeight: document.documentElement.scrollHeight - 245 + "px",
        ijeudid:-1,
        indexdw:-1,
         isIndeterminate: true,
         checkAll: false,
         kiejfur:[]
      };
    },

    created() {
      this.getDicts("role_data").then(response => {
        this.statusOptions = response.data;
        this.relationType = response.data
        this.getDeptTreeselect()
      });
      this.getList();

    },
    filters: {
      relationTypeFn(data) {
        var _this = this
        let is = ''
        for (let item of that.relationType) {
          if (item.dictValue == data) {
            is = item.dictLabel
          }
        }
        return is
      },
    },
    methods: {
      handleNodeClick() {
      },
      /** 查询角色列表 */
      getList() {
        this.loading = true;
        this.roleList = []
        listRole(this.addDateRange(this.queryParams, this.dateRange)).then(
          response => {
            if(response.rows.length !==0){
              this.roleList = response.rows;
              this.totale = response.total;
            }else{
              this.roleList.push({roleName:'暂无数据'})
            }

            // this.total = response.total;
            this.loading = false;
          }
        );
      },
      /** 查询菜单树结构 */
      getMenuTreeselect() {
        menuTreeselect().then(response => {
          this.menuOptions = response.data;
        });
      },
      /** 查询列表数据*/
      getDeptTreeselect() {
        listPostporen(this.queryParamstr).then(response => {
          this.cloumns = response.rows;
          this.total = response.total
          // this.cloumns.
          this.cloumns.filter(route => {
              for(var item in route){
                if(item == 'dataScope'){
                  console.log(route[item])
                  console.log(this.relationType)
                  this.relationType.filter(router =>{
                    console.log(router)
                    if(router.dictValue == route[item]){
                      route[item] = router.dictLabel
                    }
                  })
                }
              }
          })
        });
      },
      /** 根据角色ID查询菜单树结构 */
      getRoleMenuTreeselect(id) {
        return roleMenuTreeselect(id).then(response => {
          this.menuOptions = response.menus;
          return response;
        });
      },
      /** 根据角色ID查询部门树结构 */
      getRoleDeptTreeselect(id) {
        return roleDeptTreeselect(id).then(response => {
          this.deptOptions = response.depts;
          return response;
        });
      },
      // 角色状态修改
      handleStatusChange(row) {
        let text = row.status === "0" ? "启用" : "停用";
        this.$confirm('确认要"' + text + '""' + row.roleName + '"角色吗?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return changeRoleStatus(row.id, row.status);
        }).then(() => {
          this.msgSuccess(text + "成功");
        }).catch(function() {
          row.status = row.status === "0" ? "1" : "0";
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 取消按钮（数据权限）
      cancelDataScope() {
        this.openDataScope = false;
        this.reset();
      },
      // 表单重置
      reset() {

          this.form = {
          };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.dateRange = [];
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length != 1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        // this.getMenuTreeselect();
        this.open = true;
        this.title = "添加数据权限";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids
        // const roleMenu = this.getRoleMenuTreeselect(id);
        getRoler(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.$nextTick(() => {
            roleMenu.then(res => {
              let checkedKeys = res.checkedKeys
              checkedKeys.forEach((v) => {
                this.$nextTick(() => {
                  this.$refs.menu.setChecked(v, true, false);
                })
              })
            });
          });
          this.title = "修改数据权限";
        });
      },
      /** 选择角色权限范围触发 */
      dataScopeSelectChange(value) {
        if (value !== '2') {
          this.$refs.dept.setCheckedKeys([]);
        }
      },
      /** 分配数据权限操作 */
      handleDataScope(row) {
        this.reset();
        const roleDeptTreeselect = this.getRoleDeptTreeselect(row.id);
        getRole(row.id).then(response => {
          this.form = response.data;
          this.openDataScope = true;
          this.$nextTick(() => {
            roleDeptTreeselect.then(res => {
              this.$refs.dept.setCheckedKeys(res.checkedKeys);
            });
          });
          this.title = "分配数据权限";
        });
      },
      /** 提交按钮 */
      submitForm: function() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != undefined) {
              // this.form.menuIds = this.getMenuAllCheckedKeys();
              piutRoler(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getDeptTreeselect();
              });
            } else {
              // this.form.menuIds = this.getMenuAllCheckedKeys();
              this.form.roleId = this.ijeudid
              if(this.form.roleId !== -1){
                addlistPostporen(this.form).then(response => {
                  this.msgSuccess("新增成功");
                  this.open = false;
                  this.getDeptTreeselect();
                });
              }else{
                this.msgSuccess("请先选择角色在添加");
                this.open = false
              }
            }
          }
        });
      },
      /** 提交按钮（数据权限） */
      submitDataScope: function() {
        if (this.form.id != undefined) {
          this.form.deptIds = this.getDeptAllCheckedKeys();
          dataScope(this.form).then(response => {
            this.msgSuccess("修改成功");
            this.openDataScope = false;
            // this.getDeptTreeselect();
          });
        }
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$confirm('是否确认删除角色编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delelistPostporen(ids);
        }).then(() => {
          this.getDeptTreeselect();
          this.msgSuccess("删除成功");
        })
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download('system/role/export', {
          ...this.queryParams
        }, `role_${new Date().getTime()}.xlsx`)
      },
      // 查询
      quregu(){
        this.getList()
      },
      // 刷新
      efresh(){
       this.queryParams.roleName = undefined
       this.getList()
       this.queryParamstr.roleId = undefined
       this.getDeptTreeselect()
      },
      // 点击角色id
      jieese(id,index){
        this.indexdw = index
        this.ijeudid = id
        this.queryParamstr.roleId = id
        this.getDeptTreeselect()
      },
      handleCheckAllChange(val) {
              if(val == true){
                this.cloumns.filter(router =>{
                  router.isUse = 'Y'
                })
              }else{
                this.cloumns.filter(router =>{
                  router.isUse = 'N'
                })
              }
              this.isIndeterminate = false;
      },
       handleCheckedCitiesChange(value) {
       }
    }
  };
</script>
<style lang="scss">
  .roleContrBoxthy{
    position: relative;
    .pagination-container{
      // position: fixed;
      position: absolute;
      bottom: 10px;
      right: 20px;
      margin-top: 87px;
    }
  }
  .app-containerth{
    .pajie{
      bottom: 30px;
    }
  }
</style>
<style lang="scss" scoped>
  .roleContrBox {
    background-color: #fff;
    // border-radius: 6px;
    overflow: hidden;
    padding: 23px 0;
    height: calc(95vh - 168px);;
  }

  .roleContr {
    padding-left: 17px;
    height: calc(100% - 168px);
    .searContLeft {
      padding:0 17px 23px 23px;
      // border-right: 2px solid #E5E5E5;
    }

    .searContRight {
      padding-left: 18px;

      .searTitle {
        display: flex;
        padding-left: 11px;
        margin-bottom: 26px;

        .searName {
          color: #343434;
          font-size: 12px;
          width: 156px;
        }

        .searItem {
          flex: 1;
          font-size: 12px;
        }
      }

      .searCont {
        display: flex;
        height: 23px;
        padding-left: 11px;
        align-items: center;
        margin-bottom: 4px;
        cursor: pointer;

        .searName {
          color: #343434;
          font-size: 12px;
          width: 156px;
        }

        .searItem {
          flex: 1;
          font-size: 12px;
        }

        &:hover {
          background-color: rgba(0, 0, 0, .1);
        }
      }

      .active {
        background-color: #CADBE4 !important;

        .searName {
          color: #fff;
        }
      }
    }
  }
 .searBoxstu{
    // height: 100vh;
    // height: calc(100vh - 70px);
    // background-color: #fff;
 }
  .searBoxs {
    background-color: #fff;
    border-radius: 6px;
    padding: 23px;
    height: calc(100vh - 140px); ;
    min-height: calc(100vh - 140px);
    .searBox {
      display: flex;

      .searInput {
        flex: 1;
        height: 32px;
        margin-right: 8px;
        box-sizing: border-box;
        border-radius: 4px;
        overflow: hidden;
      }

      input {
        width: 100%;
        height: 100%;
        background-color: #F7F6F6;
        border: none;
        padding: 0 7px;
        outline: none;

        &::placeholder {
          color: #AAAAAA;
          font-size: 12px;
        }
      }

      .searBtn {
        width: 30px;
        height: 32px;
        display: flex;
        justify-content: center;
        align-items: center;
        background-color: #3C8DBC;
        cursor: pointer;
         border-radius: 4px;
         overflow: hidden;
        .icon {
          width: 18px;
          height: 17px;
        }
      }
    }

    .searList {
      padding: 10px 0;
      height: 70%;
      .searItem {
        padding: 0 8px;
        line-height: 30px;
        font-size: 12px;
        color: #343434;
        cursor: pointer;
      }

      .active {
        background-color: #CADBE4;
        color: #3C8DBC;
      }
    }
  }

  .app-container {
    background-color: #EFF0FF;
    // min-height: calc(100vh - 70px);
    box-sizing: border-box;
    box-sizing: border-box;
  }

  .roleBox {
    padding: 0 23px;
    background: #fff;
    // border-radius: 6px;

    .roleCol {
      padding: 20px 0;
      border-bottom: 1px solid #E5E5E5;

      .roleH {
        width: 18px;
        height: 8px;
        border-radius: 4px;
        background-color: #3C8DBC;
        margin-bottom: 8px;
      }

      span {
        font-size: 15px;
        color: #3C8DBC;
      }
    }

    .roleBot {
      padding: 22px 0;
      padding-bottom: 0;
      .roleBtn {
        height: 32px;
        display: flex;
        border-radius: 3px;
        justify-content: center;
        align-items: center;
        width: 83px;
        margin-right: 18px;

        .icon {
          width: 14px;
          height: 14px;
          margin-right: 7px;
        }

        span {
          color: #fff;
          font-size: 12px;
        }
      }
    }
  }
  .roleBotyu{
    padding: 0;
    padding-bottom: 22px;
    padding-top: 1px;
    }
   .roleBoxui{
     padding-left: 0;
   }
</style>
<style>
  .el-icon-my-export{
      background: url('~@/assets/images/icon_btn_bc@2x.png') center no-repeat;
      background-size: 13px 13px;
     /* background-size: cover;*/
  }
  .el-icon-my-export:before{
      content: "替";
      font-size: 16px;
      visibility: hidden;
  }


  .el-icon-my-export{
      font-size: 16px;
  }
  .el-icon-my-export:before{
      content: "\e611";
  }
</style>
